CURLOPT_DOH_URL(3)

NAME
CURLOPT_DOH_URL - provide the DNS-over-HTTPS URL

SYNOPSIS
#include <curl/curl.h>

CURLcode curl_easy_setopt(CURL *handle, CURLOPT_DOH_URL, char *URL);

DESCRIPTION
Pass in a pointer to a URL for the DOH server to use for name resolving. The parameter should be a char * to a zero terminated string which must be URL-encoded in the following format: "https://host:port/path". It MUST specify a HTTPS URL.

libcurl doesn't validate the syntax or use this variable until the transfer is issued. Even if you set a crazy value here, curl_easy_setopt(3) will still return CURLE_OK.

curl sends POST requests to the given DNS-over-HTTPS URL.

To find the DOH server itself, which might be specified using a name, libcurl will use the default name lookup function. You can bootstrap that by providing the address for the DOH server with CURLOPT_RESOLVE(3).

Disable DOH use again by setting this option to NULL.

DEFAULT
NULL - there is no default DOH URL. If this option isn't set, libcurl will use the default name resolver.

PROTOCOLS
All

EXAMPLE
CURL *curl = curl_easy_init();
if(curl) {
  curl_easy_setopt(curl, CURLOPT_URL, "http://example.com");
  curl_easy_setopt(curl, CURLOPT_DOH_URL, "https://dns.example.com");
  curl_easy_perform(curl);
}

AVAILABILITY
Added in 7.62.0

RETURN VALUE
Returns CURLE_OK on success or CURLE_OUT_OF_MEMORY if there was insufficient heap space.

Note that curl_easy_setopt(3) won't actually parse the given string so given a bad DOH URL, curl will not detect a problem until it tries to resolve a name with it.

SEE ALSO
CURLOPT_VERBOSE(3), CURLOPT_RESOLVE(3),